/* voronoi.h is part of VIP program
 * Written by J. Salvador Arias, 2010
 *      CONICET, INSUE, Instituto Miguel Lillo,
 *      Miguel Lillo 205, S.M. de Tucuman (4000)
 *      Tucuman, Argentina
 *      e-mail: jsalarias@csnat.unt.edu.ar
 *
 * VIP is a free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation and
 * Creative Commons.
 *
 * This file and the VIP program is distributed in the hope
 * that it will be useful, but WITHOUT ANY WARRANTY; without
 * even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this file; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 * Or download it at:
 * http://creativecommons.org/licenses/GPL/2.0/
 */

#ifndef VORONOI_HEADER_INCLUDED
#define VORONOI_HEADER_INCLUDED

/* ------ Data types for the Voronoi "line" used to mark disjunctions ------ */

#include "biogeo.h"
#include "grid.h"
#include "bitfield.h"

#define STATE_NOCELL 0
#define STATE_SETA   1
#define STATE_SETB   2

typedef struct tagBEACHARC BEACHARC;
struct tagBEACHARC {
 SCOUNTER baseCell;
 SREAL baseRow;
 SREAL baseCol;
 SREAL baseState;
 GList* event;
 SREAL lastCol;
 SREAL lastLeft;
 SREAL lastRight;
 SFLAG toDel;
};

typedef struct tagDELAUNAYTRIANGLE DELAUNAYTRIANGLE;
struct tagDELAUNAYTRIANGLE {
 SCOUNTER cellA;
 SCOUNTER cellB;
 SCOUNTER cellC;
 SFLAG stateA;
 SFLAG stateB;
 SFLAG stateC;
 SREAL cX;
 SREAL cY;
 SCOUNTER abNeighbor;
 SCOUNTER acNeighbor;
 SCOUNTER bcNeighbor;
};

typedef struct tagCIRCEVENT CIRCEVENT;
struct tagCIRCEVENT {
 GList* pArc;
 SREAL circleCol;
 SREAL cX;
 SREAL cY;
};

GPtrArray* MakeVoronoi (BITFIELD* iniA, BITFIELD* iniB);
void DestroyTriangleList (GPtrArray* triangleList);

#endif
